<template>
  <div
    class="card"
    :class="editing ? 'orange' : ''"
  >
    <div class="content">
      <div class="header">
        <div class="ui fluid input transparent">
          <input
            type="text"
            v-model="data_firstname"
            placeholder="Prénom"
          >
        </div>
        <div class="ui fluid input transparent">
          <input
            type="text"
            v-model="data_lastname"
            placeholder="Nom"
          >
        </div>
      </div>
      <div class="meta">{{ patient.pavillon ? 'Pav. ' + patient.pavillon.name : '' }}</div>
      <div class="description">

        <div
          class="ui toggle checkbox"
          :class="data_hasOrdinaryDiet ? 'checked' : ''"
          @click="toggleHasOrdinaryDiet"
        >
          <input
            type="checkbox"
            :checked="data_hasOrdinaryDiet"
          >
          <label>Régime ordinaire</label>
        </div>
        <br/>

        <dropdown-diets
          :initialDiets="dietsIds"
          v-if="!data_hasOrdinaryDiet"
          @dietsChanged="updateDiets"
        >
        </dropdown-diets>
        <br/>

        <radio-eating-place
          @updateEatingPlace="updateEatingPlace"
          :eatingPlace="data_eatingPlace"
        >
        </radio-eating-place>
      </div>
      <br/>

      <div class="ui small basic icon right floated buttons">
        <div
          class="ui button"
          @click="remove"
        >
          <i class="ui red trash icon"></i>
        </div>
        <div
          class="ui button"
          v-show="editing"
          @click="validateUpdate"
        >
          <i class="ui green save icon"></i>
        </div>
      </div>

    </div>

  </div>
</template>

<script>
import DropdownDiets from '@/components/diets/DropdownDiets'
import RadioEatingPlace from './RadioEatingPlace'

import store from '@/store/Store'

export default {
  name: 'PatientCard',
  store,
  props: {
    patient: Object
  },
  data () {
    return {
      editing: false,
      data_firstname: this.patient.firstname,
      data_lastname: this.patient.lastname,
      data_hasOrdinaryDiet: this.patient.hasOrdinaryDiet,
      data_diets: this.patient.diets,
      data_eatingPlace: this.patient.eatingPlace
    }
  },
  watch: {
    hasOrdinaryDiet () {
      this.data_hasOrdinaryDiet = this.patient.hasOrdinaryDiet
    },
    data_firstname () {
      this.editing = true
    },
    data_lastname () {
      this.editing = true
    },
    data_pavillon () {
      this.editing = true
    }
  },
  mounted () {
    this.editing = false
  },
  methods: {
    remove () {
      this.$emit('removePatient', this.patient._id) // catché dans Patients.vue
    },
    toggleHasOrdinaryDiet () {
      this.editing = true
      this.data_hasOrdinaryDiet = !this.data_hasOrdinaryDiet
    },
    updateDiets (value) {
      this.editing = true
      this.data_diets = []
      if (value !== '') {
        value.split(',').forEach(dietId => {
          this.data_diets.push({ _id: dietId })
        })
      }
    },
    updateEatingPlace (place) {
      this.editing = true
      this.data_eatingPlace = place
    },
    validateUpdate () {
      let newData = {
        _id: this.patient._id,
        firstname: this.data_firstname,
        lastname: this.data_lastname,
        hasOrdinaryDiet: this.data_hasOrdinaryDiet,
        diets: this.data_diets,
        eatingPlace: this.data_eatingPlace
      }

      store.dispatch('PatientsStore/updatePatient', newData)
        .then((response) => {
          this.$emit('updatePatient') // dégueulasse de tout faire recharger mais pas d'autre solution
          this.editing = false
          this.$toastr.s(response.firstname + ' ' + response.lastname + ' bien modifié')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    }
  },
  computed: {
    fullname () {
      return this.data_firstname + ' ' + this.data_lastname
    },
    dietsIds () {
      let ids = []
      this.patient.diets.forEach(d => {
        ids.push(d._id)
      })
      return ids
    }
  },
  components: {
    DropdownDiets,
    RadioEatingPlace
  }
}
</script>
